﻿Type=Class
Version=4.2
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'WebSocket class
Sub Class_Globals
	Private ws As WebSocket
	Private timer1 As Timer
	Private connected As Boolean
End Sub

Public Sub Initialize
	
End Sub

Private Sub WebSocket_Connected (WebSocket1 As WebSocket)
	ws = WebSocket1
	timer1.Initialize("timer1", 1000)
	timer1.Enabled = True
	connected = True
	Main.ConnectedArduino = Me
	Log("Arduino Connected")
End Sub

Public Sub SetLed(LedId As String, State As Boolean)
	If connected = False Then Return
	'Must be an array of strings and the parameters cannot include quotes.
	ws.RunFunction("Led", Array As String(LedId.SubString("arduino_led".Length), State))
	ws.Flush
End Sub

Sub Btn_StateChanged (Params As Map)
	Dim id As String = "arduino_btn" & Params.Get("btn")
	Dim state As Boolean = Params.Get("state")
	For Each br As Browser In Main.ConnectedBrowsers.Keys
		CallSubDelayed3(br, "UpdateButton", id, state)
	Next
End Sub

Sub Timer1_Tick
	ws.RunFunction("ServerTime", Array As String(DateTime.Time(DateTime.Now)))
	ws.Flush
End Sub

Private Sub WebSocket_Disconnected
	timer1.Enabled = False
	connected = False
End Sub