﻿Type=Class
Version=4.2
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'WebSocket class
Sub Class_Globals
	Private ws As WebSocket
	Private arduino_led0 As JQueryElement
	Private arduino_led1 As JQueryElement
End Sub

Public Sub Initialize
	
End Sub

Private Sub WebSocket_Connected (WebSocket1 As WebSocket)
	ws = WebSocket1
	Main.ConnectedBrowsers.Put(Me, "")
	arduino_led0.RunMethod("toggles", Array As Object(CreateMap("on": False)))
	arduino_led1.RunMethod("toggles", Array As Object(CreateMap("on": False)))
End Sub

Public Sub Led_Toggle(Params As Map)
	Dim id As String = Params.Get("id")
	Dim active As Boolean = Params.Get("active")
	CallSubDelayed3(Main.ConnectedArduino, "SetLed", id, active)
End Sub

Public Sub UpdateButton (id As String, State As Boolean)
	Dim jq As JQueryElement = ws.GetElementById(id)
	Dim html As String
	If State Then html = "<b>Down</b>" Else html = "Up"
	jq.SetHtml(html)
	ws.Flush
End Sub

Private Sub WebSocket_Disconnected
	Main.ConnectedBrowsers.Remove(Me)
End Sub

